<template>
  <div :class="['ob-accordion', open && !isDisabled ? 'opened' : 'closed']">
    <div class="ob-accordion__title" @click="onAccordionClick">
      <div class="ob-accordion__icon-container">
        <i
          v-if="!isDisabled"
          class="chevron icon chevron-down"
          :class="[open ? 'opened' : 'closed']"
        />
        <i v-if="icon" class="additional-icon" :class="['icon', icon]"/>
      </div>
      <template v-if="isEditable">
        <div v-if="title" class="ob-accordion__title-input">
          <input
            v-model="localTitle"
            class="input"
            type="text"
            @change="onChange"
            @click.stop
          />
        </div>
      </template>
      <template v-else>
        <div v-if="title" class="ob-accordion__title-text">
          {{ title }}
        </div>
      </template>

      <slot name="title-content" />
    </div>

    <ObExpandTransition>
      <div v-if="open && !isDisabled" class="ob-accordion__content">
        <slot />
      </div>
    </ObExpandTransition>

  </div>
</template>
<script>
import ObExpandTransition from 'common-components/src/obComponents/obExpandTransition'

export default {
  name: 'ObAccordion',
  components: {
    ObExpandTransition
  },
  props: {
    isOpen: {
      type: Boolean,
      default: () => false
    },
    icon: {
      type: String
    },
    title: {
      type: String
    },
    isEditable: {
      type: Boolean,
      default: () => false
    },
    isDisabled: {
      type: Boolean,
      default: () => false
    }
  },
  data() {
    return {
      open: this.isOpen,
      localTitle: this.title,
    }
  },
  watch: {
    isOpen: {
      handler() {
        this.open = this.isOpen
      },
      immediate: true
    }
  },
  methods: {
    onAccordionClick () {
      if (!this.isDisabled) {
        this.open = !this.open
      }
    },
    onChange () {
      this.$emit('change', this.localTitle)
    }
  }
}
</script>
<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.ob-accordion {
  display: flex;
  background: transparent;
  flex-direction: column;
  width: 100%;
  margin-bottom: 1px;

  &__title {
    padding: 20px 22px;
    display: flex;
    cursor: pointer;
    background: $blue-150;
    align-items: center;

    &-input {
      margin-left: -15px;
      flex-grow: 1;

      input{
        font-size: 16px;
        color: $blue-dust;
        flex-grow: 1;
        background: transparent;
        border: 1px solid transparent;
        height: 30px;
        border-radius: 3px;
        transition: all 0.2s linear;
        padding: 0 12px;
        outline: none;
        width: 100%;

        &:hover{
          border: 1px solid $color-grey-border;
          background: $white;
          color: $cobalt-black;
        }

        &:focus, &:focus-visible{
          color: $cobalt-black;
          background: $white;
          border-color: $color-blue-navy-blue;
          box-shadow: inset 0 3px 6px rgba(25,30,50,0.1);
        }
      }
    }

    &-text {
      font-size: 16px;
      flex-grow: 1;
    }

  }

  &__icon-container{
    position: relative;
    width: 120px;

    .additional-icon{
      position: absolute;
      top: 50%;
      left: 40px;
      font-size: 16px;
      transform: translateY(-50%);
      color: $blue-dust;
    }

    .chevron {
      position: absolute;
      top: 50%;
      left: 0px;
      transform: translateY(-50%);
      font-size: 23px;
      color: $blue-dust;
      transition: all 0.2s linear;

      &.closed {
        transform: translateY(-50%) rotate(-90deg);
      }
    }
  }

  &__content {

  }
}

</style>
